package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EEnterpriseInfo;
import com.zksy.info.domain.EEnterprisePowerInfo;
import com.zksy.info.service.EEnterpriseInfoService;
import com.zksy.info.service.EEnterprisePowerInfoService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 企业用电控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/enterprisePowerInfo")
@Api(tags = "企业用电信息",description = "企业用电信息desc")
public class EEnterprisePowerInfoController {
    @Autowired
    private EEnterprisePowerInfoService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "企业用电信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String enterpriseName){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, enterpriseName));
    }
    @GetMapping("/getEnterpriseInfoList")
    @ApiOperation(value = "企业用电信息")
    public AjaxResult getEnterpriseInfoList(String enterpriseName){
        return AjaxResult.success(service.getEEnterprisePowerInfoList(enterpriseName));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询企业用电信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "企业用电信息保存")
    public AjaxResult save(@RequestBody EEnterprisePowerInfo eEnterprisePowerInfo) {
        return service.save(eEnterprisePowerInfo) ? AjaxResult.success(eEnterprisePowerInfo) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "企业用电信息修改")
    public AjaxResult update(@RequestBody EEnterprisePowerInfo eEnterprisePowerInfo) {
        eEnterprisePowerInfo.setUpdateTime(LocalDateTime.now());
        return service.updateById(eEnterprisePowerInfo) ? AjaxResult.success(eEnterprisePowerInfo) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "企业用电信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EEnterprisePowerInfo.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String enterpriseName) {
        ExcelExportUtil.exportExcel(response,service.getEEnterprisePowerInfoList(enterpriseName), EEnterprisePowerInfo.class, "企业用电信息","企业用电信息");
    }

}
